/*
	DUALPLAYER V1.00 (c) by Tinic Uro

	Player class
*/	
#include "zoonic.h"

/* 
	Methods
*/
enum
{
	P_LOAD			=0x100,				// int handle (char *filename)
	P_FREE			=0x101,				// void (int handle)
	P_RESUME		=0x103,				// void (int handle)
	P_PAUSE			=0x104,				// void (int handle)
	P_SETUPSTREAM	=0x105,				// void (BAudioSubscriber *auds)
	P_STREAM		=0x106,				// bool (char *buffer, int size)
	P_CREATEINFO	=0x107,				// void (char ***info, int *lines)
	P_FREEINFO		=0x108,				// void (char ***info, int *lines)
	P_DRAWSTATUS	=0x109,				// void (BView *view)
	P_POSITIONSTRING=0x10a,				// void (char *str, int allowedlength, int value)
	P_SETATTR		=B_METHOD_SETATTR,	// int (TagItem *items)
	P_GETATTR		=B_METHOD_GETATTR,	// int (TagItem *items)
};

/*
	Attributes
*/
enum
{
	P_ATTR_STREAMARG=0x10,				// -G-	Argument which should be forwarded to P_STREAM, default is 0
	P_ATTR_MODLENGTH,					// -G-	Module/File-length, default is 0
	P_ATTR_MODPOS,						// SG-	actual Module/File-position, must be between 0 and P_ATTR_MODLENGTH. If set, forward to requested position., default is 0
	P_ATTR_TRACKNUM,					// -G-  Number of tracks, return 0 when there are none. default is 0
	P_ATTR_TRACK,						// SG-  Actual track. When set, forward to requested track. default is 0
	P_ATTR_UNUSED,						// ---
	P_ATTR_BOOST,						// S--  Volume 0..128. Anything over 128 is a special boost and is VALID...
	P_ATTR_LOOP,						// S--  Loop file when possible, preferably without reloading
	P_ATTR_ID,							// -G-  ID string which appears on the list. default is "Your player name".
	P_ATTR_PREFS,						// S--  Access to the main preferences BMessage. Store your own preferences in here.
	P_ATTR_VIEW,						// -G-  Return a valid BView. It should contain preferences stuff. Size should be BRect(0,0,199,179). default is an empty BView.
	P_ATTR_RECOGNITION					// -G-	0..100%. 0% = The file is hardly recognizable, 100% = The file can be itendified without any problem. default is 25.
};										//
										// |||
										// ||+- Direct return
										// ||
										// |+-- Getable Attribute
										// |
										// +--- Setable Attribute

