/*
	ZOONIC RELEASE 2

	(c)1997 by Tinic Urou
*/
#ifndef __ZOONIC__
#define __ZOONIC__

#include <stdarg.h>
#include <string.h>
#include <memory.h>
#ifdef __cplusplus
#include <StorageKit.h>
#endif

#define MAX_CLASSNAMELENGTH		63

struct			Class;
struct			Object;
struct 			TagItem;
long 			CreatezOOnic(void);
void 			DestroyzOOnic(void);
Class			*OpenzOOnicClass(char *classname, long minversion);			
struct TagItem 	*FindTagItem(struct TagItem *tags, int TagID );
int				GetTagData(struct TagItem *tags, int defval, int TagID );

#pragma export on
char *class_superclass();
long class_instancesize();
long class_superversion();
long class_version();
long class_dispatcher(Class *c, Object *o, ulong MethodID, ulong *data);
#pragma export off

#ifndef __cplusplus
Class 	*CreateClass	(Class *superclass,char *superclassname,long instancesize, long (*dispatcher)(Class *c, Object *o,ulong MethodID, ulong *data));
void 	DestroyClass	(Class *c);
void 	SetClassError	(Class *c, long errorcode);
long 	ClassError		(Class *c);
Class 	*OpenClass		(char *baseclassname);

Object 	*CreateObject	(Class *baseclass,char *baseclassname, ...);
void 	DestroyObject	(Object *o);
long	DoMethod		(Object *o, ulong MethodID, ...);
void	SetObjectError	(Object *o, long errorcode);
long 	ObjectError		(Object *o);
long 	DoSuperMethod	(Class *c,Object *o,ulong MethodID, ulong *data);
void 	*Instance		(Class *c,Object *o);
#endif

enum
{
	TAG_END=0,
	TAG_DONE=0,
	TAG_SKIP=-1,
	TAG_MORE=-2
};

struct TagItem
{
	int	TagID;
	int	TagData;
};

enum
{
	B_METHOD_CONSTRUCT=0xFF000000,
	B_METHOD_DESTROY,
	B_METHOD_SETATTR,
	B_METHOD_GETATTR
};

enum
{
	B_UNKNOWN_CLASS = B_ERRORS_END + 1,
	B_BADSUPER_CLASS,
	B_UNKNOWN_METHOD
};

struct Class
{
	Class		*_nextclass;
	long 	   (*_dispatcher)(Class *c, Object *o, ulong MethodID, ulong *data);
	Class		*_superclass;
	long		 _instanceoffset;
	long		 _instancesize;
	long		 _error;

	char		*_classname;
	long 		 _version;
	char		*_superclassname;

	image_id	 _image_id;

#ifdef __cplusplus
				Class(Class *superclass, long instancesize, long (*dispatcher)(Class *c, Object *o,ulong MethodID, ulong *data));
				Class(char *superclassname, long superminversion, long instancesize, long (*dispatcher)(Class *c, Object *o,ulong MethodID, ulong *data));
				~Class();

	void		SetError(long errorcode);
	long		Error();
	
#endif
};

struct Object
{
	Class		*_baseclass;
	void		*_instance;
	long		 _error;

#ifdef __cplusplus
				Object(Class *baseclass, ...);
				Object(char *baseclassname, long minversion ...);
				~Object();

	inline long DoMethod(ulong MethodID, ...)
	{
		_error=B_NO_ERROR;
	
		va_list	argptr;
		va_start (argptr,MethodID);
		long ret=_baseclass->_dispatcher(_baseclass,this,MethodID,(ulong *)argptr);
		va_end(argptr);
	
		return ret;
	};
	
	inline long DoSuperMethod(Class *c,ulong MethodID, ulong *data)
	{
		_error=B_NO_ERROR;		
		return c->_superclass->_dispatcher(c->_superclass,this,MethodID,data);
	};

	inline void	*Instance(Class *c)
	{
		_error=B_NO_ERROR;
		return (void *)((uchar *)_instance+c->_instanceoffset);
	};	

	inline void SetError(long errorcode)
	{
		_error=errorcode;
	};
	
	inline long Error()
	{
		return _error;
	};
#endif
};
#endif
